#include "smgbalib.h"
#include "intro.h"
#include "graphics.h"
#include "gauges.h"

// private - decorations for the game over screen :D
void DecorateScreen( void ) {
	u16 x, y;
	
	for(x=0; x< 10; x++ ) {
		if( x % 2 ) {
			DrawBitmapOpaque( 0 + 12*x, 0, food_HEIGHT, food_WIDTH, (u16*)greenbellpepperData );
			DrawBitmapOpaque( 0 + 12*x, 136, food_HEIGHT, food_WIDTH, (u16*)burgerData );
		} else {
			DrawBitmapOpaque( 0 + 12*x, 0, food_HEIGHT, food_WIDTH, (u16*)burgerData );
			DrawBitmapOpaque( 0 + 12*x, 136, food_HEIGHT, food_WIDTH, (u16*)greenbellpepperData );
		}
	}
	
	WriteStringWide( 38, 25, "GAME OVER" );
	
	WriteStringWide( 25, 102, "Your score was" );
	
	char result[] = "           ";
	Itoa( result, Score );
	WriteStringWide( 85, 102, result );
	
	WriteStringWide( 35, 120, "Press Start!" );
}

// private - wait for a press and release of start button to return to main screen
void WaitForStartButton( void ) {
	while(!IS_START_PRESSED) {
		NextRandom( 1 );
	}
	while(IS_START_PRESSED){}
	PlayNote( NOTE_E7, 16 );
	Sleep(16);
	PlayNote( NOTE_F7, 16 );
	Sleep(16);
	PlayNote( NOTE_G7, 16 );
	Sleep(128);
}

void ShowIntroScreen( void ) {
	
	SetPalette( (u16*)intrologoPalette );
	DrawFullScreenOpaque( (u16*)intrologoData );
	Flip();
	
	PlayWhiteNoise( WHITE_NOISE_SPLASH );
	
	Sleep(750);
}

void ShowWaitForStartScreen( void ) {
	
	u16 c;
	SetPalette( (u16*)intropressstartPalette );
	DrawFullScreenOpaque( (u16*)intropressstartData );
	
	WriteStringWide( 32, 0, "High Score" );
	char result[] = "           ";
	Itoa( result, HighScore );
	WriteStringWide( 75, 0, result );
	
	Flip();
	
	// infinite loop, broken by a return when start is pressed
	while(1) {
		PlayNote( NOTE_E4, 64 );Sleep(256);NextRandom( 1 );if(IS_START_PRESSED){ while(IS_START_PRESSED){} return; }
		
		PlayNote( NOTE_D4, 64 );Sleep(64);NextRandom( 1 );if(IS_START_PRESSED){ while(IS_START_PRESSED){} return; }
		PlayNote( NOTE_CSHARP4_DFLAT4, 64 );Sleep(64);NextRandom( 1 );if(IS_START_PRESSED){ while(IS_START_PRESSED){} return; }
		PlayNote( NOTE_C4, 255 );Sleep(255);NextRandom( 1 );if(IS_START_PRESSED){ while(IS_START_PRESSED){} return; }
		
		for(c=0; c<4; c++) {
			PlayNote( NOTE_E3, 32 );Sleep(32);NextRandom( 1 );if(IS_START_PRESSED){ while(IS_START_PRESSED){} return; }
			PlayNote( NOTE_E3, 32 );Sleep(32);NextRandom( 1 );if(IS_START_PRESSED){ while(IS_START_PRESSED){} return; }
			PlayNote( NOTE_E4, 32 );Sleep(32);NextRandom( 1 );if(IS_START_PRESSED){ while(IS_START_PRESSED){} return; }
			
			PlayNote( NOTE_E3, 32 );Sleep(32);NextRandom( 1 );if(IS_START_PRESSED){ while(IS_START_PRESSED){} return; }
			PlayNote( NOTE_E3, 32 );Sleep(32);NextRandom( 1 );if(IS_START_PRESSED){ while(IS_START_PRESSED){} return; }
			PlayNote( NOTE_DSHARP4_EFLAT4, 32 );Sleep(32);NextRandom( 1 );if(IS_START_PRESSED){ while(IS_START_PRESSED){} return; }
			
			PlayNote( NOTE_E3, 32 );Sleep(32);NextRandom( 1 );if(IS_START_PRESSED){ while(IS_START_PRESSED){} return; }
			PlayNote( NOTE_E3, 32 );Sleep(32);NextRandom( 1 );if(IS_START_PRESSED){ while(IS_START_PRESSED){} return; }
			
			PlayNote( NOTE_D4, 64 );Sleep(64);NextRandom( 1 );if(IS_START_PRESSED){ while(IS_START_PRESSED){} return; }
			PlayNote( NOTE_CSHARP4_DFLAT4, 64 );Sleep(64);NextRandom( 1 );if(IS_START_PRESSED){ while(IS_START_PRESSED){} return; }
			PlayNote( NOTE_C4, 128 );Sleep(128);NextRandom( 1 );if(IS_START_PRESSED){ while(IS_START_PRESSED){} return; }
			
			PlayNote( NOTE_E3, 32 );Sleep(32);NextRandom( 1 );if(IS_START_PRESSED){ while(IS_START_PRESSED){} return; }
			PlayNote( NOTE_E3, 32 );Sleep(32);NextRandom( 1 );if(IS_START_PRESSED){ while(IS_START_PRESSED){} return; }
			PlayNote( NOTE_B3, 32 );Sleep(32);NextRandom( 1 );if(IS_START_PRESSED){ while(IS_START_PRESSED){} return; }
			
			PlayNote( NOTE_E3, 32 );Sleep(32);NextRandom( 1 );if(IS_START_PRESSED){ while(IS_START_PRESSED){} return; }
			PlayNote( NOTE_E3, 32 );Sleep(32);NextRandom( 1 );if(IS_START_PRESSED){ while(IS_START_PRESSED){} return; }
			PlayNote( NOTE_ASHARP3_BFLAT3, 32 );Sleep(32);NextRandom( 1 );if(IS_START_PRESSED){ while(IS_START_PRESSED){} return; }
			
			PlayNote( NOTE_E3, 32 );Sleep(32);NextRandom( 1 );if(IS_START_PRESSED){ while(IS_START_PRESSED){} return; }
			PlayNote( NOTE_E3, 32 );Sleep(32);NextRandom( 1 );if(IS_START_PRESSED){ while(IS_START_PRESSED){} return; }
			PlayNote( NOTE_A3, 32 );Sleep(32);NextRandom( 1 );if(IS_START_PRESSED){ while(IS_START_PRESSED){} return; }
			
			PlayNote( NOTE_E3, 32 );Sleep(32);NextRandom( 1 );if(IS_START_PRESSED){ while(IS_START_PRESSED){} return; }
			PlayNote( NOTE_GSHARP3_AFLAT3, 32 );Sleep(32);NextRandom( 1 );if(IS_START_PRESSED){ while(IS_START_PRESSED){} return; }
			
			PlayNote( NOTE_E3, 32 );Sleep(32);NextRandom( 1 );if(IS_START_PRESSED){ while(IS_START_PRESSED){} return; }
			PlayNote( NOTE_G3, 32 );Sleep(32);NextRandom( 1 );if(IS_START_PRESSED){ while(IS_START_PRESSED){} return; }
			
			PlayNote( NOTE_E3, 32 );Sleep(32);NextRandom( 1 );if(IS_START_PRESSED){ while(IS_START_PRESSED){} return; }
			PlayNote( NOTE_FSHARP3_GFLAT3, 32 );Sleep(32);NextRandom( 1 );if(IS_START_PRESSED){ while(IS_START_PRESSED){} return; }
		}
		
		for(c=0; c<500; c++) {
			if(IS_START_PRESSED){ while(IS_START_PRESSED){} return; }
			Sleep(1);
		}
	}
}


void ShowGameOverStarvedScreen( void ) {
	
	PlayWhiteNoise( WHITE_NOISE_CRUMBLE_HIGH );
	
	EraseScreen();EraseScreen();
	SetPalette( (u16*)mainBDPalette );
	
	DecorateScreen();
	
	WriteStringWide( 19, 35, "YOU STARVED TO DEATH" );
	WriteStringWide( 15, 65, "Remember to keep eating!" );
	
	Flip();
	WaitForStartButton();
}

void ShowGameOverUnhealthyScreen( void ) {
	
	PlayWhiteNoise( WHITE_NOISE_CRUMBLE_HIGH );
	
	EraseScreen();EraseScreen();
	SetPalette( (u16*)mainBDPalette );
	
	DecorateScreen();
	
	
	WriteStringWide( 6, 35, "YOUR DIET WAS TOO UNHEALTHY" );
	WriteStringWide( 15, 65, "Your unhealthy diet has" );
	WriteStringWide( 15, 73, "caused a heart attack!" );
	
	Flip();
	WaitForStartButton();
}

void ShowGameOverBlandScreen( void ) {
	
	PlayWhiteNoise( WHITE_NOISE_CRUMBLE_HIGH );
	
	EraseScreen();EraseScreen();
	SetPalette( (u16*)mainBDPalette );
	
	DecorateScreen();
	
	
	WriteStringWide( 15, 35, "YOUR DIET WAS TOO BLAND" );
	WriteStringWide( 15, 65, "Your bland diet has made" );
	WriteStringWide( 15, 73, "you hate life!" );
	
	Flip();
	WaitForStartButton();
}

void ShowInstructionsScreen( void ) {
	
	EraseScreen();EraseScreen();
	SetPalette( (u16*)mainBDPalette );
	
	WriteStringWide( 35, 0, "INSTRUCTIONS" );
	
	WriteStringWide( 0, 10, "Unhealthy foods:" );
	DrawBitmapTransparent( 0, 18, food_HEIGHT, food_WIDTH, (u16*)burgerData );
	DrawBitmapTransparent( 13, 18, food_HEIGHT, food_WIDTH, (u16*)tacoData );
	DrawBitmapTransparent( 26, 18, food_HEIGHT, food_WIDTH, (u16*)friesData );
	DrawBitmapTransparent( 39, 18, food_HEIGHT, food_WIDTH, (u16*)pizzaData );
	DrawBitmapTransparent( 52, 18, food_HEIGHT, food_WIDTH, (u16*)donutData );
	DrawBitmapTransparent( 65, 18, food_HEIGHT, food_WIDTH, (u16*)hotdogData );
	
	WriteStringWide( 0, 45, "Bland foods:" );
	DrawBitmapTransparent( 0, 53, food_HEIGHT, food_WIDTH, (u16*)lemonData );
	DrawBitmapTransparent( 13, 53, food_HEIGHT, food_WIDTH, (u16*)turnipData );
	DrawBitmapTransparent( 26, 53, food_HEIGHT, food_WIDTH, (u16*)mushroomData );
	DrawBitmapTransparent( 39, 53, food_HEIGHT, food_WIDTH, (u16*)greenbellpepperData );
	DrawBitmapTransparent( 52, 53, food_HEIGHT, food_WIDTH, (u16*)purplegrapeData );
	DrawBitmapTransparent( 65, 53, food_HEIGHT, food_WIDTH, (u16*)carrotData );
	
	WriteStringWide( 0, 79, "Eating" );
	
	WriteStringNarrow( 0, 89, "4 of same type = large shift in diet" );
	WriteStringNarrow( 80, 97, "[8x bonus]" );
	
	WriteStringNarrow( 0, 108, "3 of same type = medium shift in diet" );
	WriteStringNarrow( 80, 116, "[4x bonus]" );
	
	WriteStringNarrow( 0, 127, "2 of each type = small shift in diet" );
	WriteStringNarrow( 0, 134, "(either to unhealthy or bland, randomly)" );
	WriteStringNarrow( 80, 142, "[NO bonus]" );
	
	WriteStringWide( 35, 150, "Press Start!" );
	
	Flip();
	WaitForStartButton();
}
